#!/bin/sh

set -e

assert() {
	msg="$1"
	shift
	if ! test "$@"; then
		echo "assertion failure: $msg"
		echo "check failed: $*"
		exit 1
	fi
}

austin -o out python3 -m timeit "'-'.join(str(n) for n in range(100))"

samples=$(grep -c '^P' out)
timeit_samples=$(grep -c '^P.*:Timer.timeit:' out)

assert "austin: samples > 1000" "$samples" -gt 1000
assert "austin: timeit_samples * 2 >= samples" "$((timeit_samples * 2))" -ge "$samples"

austinp -o out python3 -m timeit "'-'.join(str(n) for n in range(100))"

samples=$(grep -c '^P' out)
timeit_samples=$(grep -c '^P.*:Timer.timeit:' out)

assert "austinp: samples > 30" "$samples" -gt 30
assert "austinp: timeit_samples * 3 >= samples" "$((timeit_samples * 3))" -ge "$samples"
